part of 'authentication_basic_bloc.dart';

@freezed
class AuthenticationBasicState with _$AuthenticationBasicState {
  const AuthenticationBasicState._();

  bool get authenticated {
    return authenticationData != null;
  }

  const factory AuthenticationBasicState({
    required bool authChecked,
    required bool authenticating,
    required bool deletingAccount,
    required AuthenticationData? authenticationData,
    required bool signingUp,
    required bool fetchingAuthUserData,
    required bool? authCheckFailure,
    required Failure? authenticatingFailure,
    required Failure? signingUpFailure,
    Failure? deleteAccountFailure,
    // User user,
  }) = _AuthenticationBasicBlocState;

  factory AuthenticationBasicState.initial() {
    return const AuthenticationBasicState(
      authChecked: false,
      authCheckFailure: null,
      authenticating: false,
      authenticatingFailure: null,
      authenticationData: null,
      signingUp: false,
      signingUpFailure: null,
      fetchingAuthUserData: false,
      deletingAccount: false,
    );
  }
}
