import 'package:dartz/dartz.dart';
import 'package:flutter_gb_stack_base/flutter_gb_stack_base.dart';

import '../entities/entities.dart';

abstract class AuthenticationService {
  Future<Either<Failure, AuthenticationData>> loginWithCredentials(String username, String password);
  Future<Either<Failure, AuthenticationData?>> signupWithCredentials(AuthSignUpPayload payload);
  Future<Either<Failure, AuthenticationData?>> getAuthenticatedSession();
  Future<Either<Failure, User>> fetchAuthUserData();
  Future<Either<Failure, Unit>> logout();
  Future<Either<Failure, User?>> deleteAccount(String userId);
}
