import '../../domain/domain.dart';

class AuthCredentialsProviderModel implements AuthCredentialsProvider {
  @override
  final String password;

  @override
  final String usernameOrEmail;

  AuthCredentialsProviderModel({
    required this.password,
    required this.usernameOrEmail,
  });

  @override
  bool operator ==(Object other) {
    if (identical(this, other)) return true;

    return other is AuthCredentialsProviderModel &&
        other.password == password &&
        other.usernameOrEmail == usernameOrEmail;
  }

  @override
  int get hashCode => password.hashCode ^ usernameOrEmail.hashCode;

  AuthCredentialsProviderModel copyWith({
    String? password,
    String? usernameOrEmail,
  }) {
    return AuthCredentialsProviderModel(
      password: password ?? this.password,
      usernameOrEmail: usernameOrEmail ?? this.usernameOrEmail,
    );
  }
}
